import os, sys, cgi, time
from urllib import quote_plus
import planet

def config_get(self, option, default=None):
    config=self.main.config
    if config.has_option("Planet", option):
        return config.get("Planet", option)
    else:
        return default

def run(self):

    def dump(self, path, object=None):
        if not object:
            if path:
                object = path[0]
            else:
                object = 'handler'

        if object == 'server':
            name = 'Server'
            object = self.server
        elif object == 'handler':
            name = 'Handler'
            object = self
        elif object == 'main':
            name = 'Main'
            object = self.main
        elif object == 'planet':
            name = 'Planet'
            object = self.main.my_planet
        elif object == 'channels':
            name = 'Channels'
            class object: pass
            for item in self.main.my_planet.gather_channel_info()[1]:
                object.__dict__[item['name']] = item
        elif object == 'cache':
            self.send_response(302)
            self.send_header('Location', '/debug/cache/')
            self.end_headers()
            return
        else:
            return self.send_error(404)

        self.send_response(200)
        self.send_header('Content-type', 'text/html; charset='+self.encoding)
        self.end_headers()

        dump_table(name, object)

    def wrap(value):
        class object: pass
        for key in value.keys():
             object.__dict__[key] = value[key]
        return object

    def dump_list(name, object):
        import planet.htmltmpl
        manager = planet.htmltmpl.TemplateManager()
        template = manager.prepare('planet/server/list.tmpl')
        tp = planet.htmltmpl.TemplateProcessor(html_escape=0)
        tp.set('name', name)

        tp.set('Rows', object)

        print tp.process(template)

    def dump_table(name, object):
        import planet.htmltmpl
        manager = planet.htmltmpl.TemplateManager()
        template = manager.prepare('planet/server/dump.tmpl')
        tp = planet.htmltmpl.TemplateProcessor(html_escape=0)
        tp.set('name', name)

        keys=dir(object)
        keys.sort()
        row = [{'name':name,'value':str(getattr(object,name))} for name in keys]
        tp.set('Rows', row)

        print tp.process(template)

    def demo(self, path):
        print 'hello world!'

    def cache(self, path, entry='', object=None):
        self.send_response(200)
        self.send_header('Content-type', 'text/html; charset='+self.encoding)
        self.end_headers()
 
        if path and path[0]:
            for feed in self.main.my_planet.gather_channel_info()[0]:
                if feed.cache_basename()==path[0]:
                    if entry: 
                        if entry in feed._items:
                            dump_table(entry, wrap(feed._items[entry]))
                        else:
                            self.send_error(404)
                    else:
                        rows = []
                        for key, value in feed._items.items():
                            rows.append((value['date'], {
                               'href': '/debug/cache/%s?entry=%s' % (
                                   path[0], quote_plus(key)),
                               'title': value['title'],
                               'item': key
                            }))
                        rows.sort()
                        rows.reverse()
                        dump_list(feed['name'], [row for date,row in rows])

        else:
            rows = []
            for feed in self.main.my_planet.gather_channel_info()[1]:
                cache_name = planet.cache.filename('', feed['url'])
                rows.append({
                     'href': '/debug/cache/%s' % cache_name,
                     'title': feed['name'],
                     'item': cache_name
                })
            dump_list('cache', rows)

    path,query = (self.path.split('?',1)+[""])[0:2]
    query = dict(cgi.parse_qsl(query))
    query['path'] = path.split('/')[3:]
    route = path.split('/')[2]

    saved_stdout = sys.stdout
    try: 
        sys.stdout = self.wfile

        if route in locals() and callable(locals()[route]):
            locals()[route].__call__(self, **query)
        else:
            dump(self, **query)
    finally: 
        sys.stdout = saved_stdout
